' export_kuerzel.vbs V1.2
'*********************************************************
' (C) Zaph 06/2003
' Email: zaphl@gmx.de
' Ohne Gewhr, keine Haftung!
'
' Tastaturkrzel fr Fixfoto sichern
' Fixfoto: http://www.j-k-s.com
'*********************************************************
' export_kuerzel.vbs sichert die Tastaturkrzelbelegung aus der Registry
' in die Datei [FixfotoInstallationsverzeichnis]\keys.ini
' Diese Datei wird durch import_kuerzel.vbs wieder importiert.
'
' Aufruf: Doppelklick auf diese Datei im Explorer
'
' Der Aufruf ist nur dann sinnvoll, wenn Fixfoto nicht luft!!
'
' nderungen:
' 18.03.2004  V1.1  Anpassungen an FF 2.75
' 16.05.2004  V1.2  Ermittlung des Installationspfades repariert

option explicit
Const ForReading = 1, ForWriting = 2

dim wsShell, fso

main

set fso = nothing
set wsShell = nothing
' Ende


sub main
	Dim KeyFile, KeyFileName
	dim FFPath, keys, i, ik, msg

	set wsShell = CreateObject("WScript.Shell")
	Set fso = CreateObject("Scripting.FileSystemObject")
	On Error Resume Next

	FFPath = GetFFInstPath
	if FFPath ="" then
		msgbox "Abbruch - Fixfoto-Installationsverzeichnis nicht in Registry gefunden!", VBExclamation
		exit sub
	end if

	keys = wsShell.RegRead("HKCU\Software\Joachim Koopmann Software\FixFoto\Settings\BCGKeyboard-0\Accelerators")
	if Err.number <> 0 then
		msgbox "Abbruch - BCG Settings nicht in Registry gefunden!", VBExclamation
		exit sub
	end if

	KeyFileName = FFPath & "\keys.ini"
	Set KeyFile = fso.OpenTextFile(KeyFileName, ForWriting, True)
	if Err.number <> 0 then
		msgbox "Abbruch - Kann " & KeyFileName & " nicht zum Schreiben ffnen!", VBExclamation
		exit sub
	end if

	on error goto 0

	ik = 0
	msg=""
	for i=0 to ubound(keys)-5 step 6
		if instr("13,0b,03,0f",dhex(keys(i))) = 0 then
			KeyFile.writeLine keys(i) & "," & keys(i+1) & "," & keys(i+2) & "," & keys(i+3) & "," & keys(i+4) & "," & keys(i+5)
			ik=ik+1
		end if
	next

	KeyFile.Close
	if ik = 0 then
		msg = "Keine Tastaturkrzel gefunden!"
	else
		msg = ik & " Tastaturkrzel gefunden!" & VBCrlf & "Gespeichert in: " & KeyFileName
	end if
	msgbox msg, VbInformation

end sub

function dhex(num)
	dhex=lcase(right("0" & hex(num),2))
end Function

Function GetFFInstPath
	' ermittelt den Installationspfad von Fixfoto
	On Error Resume Next

	GetFFInstPath = wsShell.RegRead("HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\DataPath")
	if Err.number = 0 Then Exit Function
	Err.number = 0
	GetFFInstPath = ""

End Function